/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2013 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/

//***********************************************************************************************************
//  Nuvoton Technology Corp. 
//  E-Mail: MicroC-8bit@nuvoton.com
//  Date: 20/May/2013
//***********************************************************************************************************

#include <stdio.h>
#include "N78E366A.h"
#include "Typedef.h"
#include "Define.h"
#include "Common.h"
#include "Delay.h"

#ifdef FOSC_110592
    #define VALUE_10us    65536-9       //9*12/11.0592 = 10 uS
    #define VALUE_1ms     65536-923     //923*12/11.0592 = 1 mS
#endif

#ifdef FOSC_184320
    #define VALUE_10us    65536-15      //15*12/18.432 = 10 uS
    #define VALUE_1ms     65536-1536    //1536*12/18.432 = 1 mS
#endif

#ifdef FOSC_221184
    #define VALUE_10us    65536-18      //9*12/22.1184 = 10 uS
    #define VALUE_1ms     65536-1843    //1843*12/22.1184 = 1 mS
#endif

#ifdef FOSC_368640
    #define VALUE_10us    65536-31      //31*12/36.864 = 10 uS
    #define VALUE_1ms     65536-3072    //3072*12/36.864 = 1 mS
#endif


//------------------------------------------------------------------------------
void Delay1ms(UINT32 u32CNT)
{
    TMOD |= 0x01;                       //Timer0 is 16-bit mode
    TR0 = 1;                            //Trigger Timer0
    while (u32CNT != 0)
    {
        TL0 = LOBYTE(VALUE_1ms); 
        TH0 = HIBYTE(VALUE_1ms);
        while (TF0 != 1);               //Check Timer0 Time-Out Flag
        TF0 = 0;
        u32CNT --;
    }
    TR0 = 0;                            //Stop the Timer0
}
