/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2013 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/

//***********************************************************************************************************
//  Nuvoton Technology Corp. 
//  E-Mail: MicroC-8bit@nuvoton.com
//  Date: 20/May/2013
//***********************************************************************************************************

/*===========================================================================================================
 * This file demos how to initialize and use PWM. An oscilloscope is needed to observe P1.3~P1.7. 
 *=========================================================================================================*/

/*
//-------- <<< Use Configuration Wizard in Context Menu >>> ------------------
//
// <h> PWM Output Enable
//     <q0.2> PWM0 output enable
//     <q0.3> PWM1 output enable
//     <q0.6> PWM2 output enable
//     <q0.7> PWM3 output enable
//     <q1.2> PWM4 output enable
// </h>
//
//-------- <<< end of configuration section >>> ------------------------------
*/

#include "N78E366A.H"

#define PWM_OUTPUT0     0xCC
#define PWM_OUTPUT1     0x04
#define SYS_CLOCK       22118400
#define PWM_PERIOD      255
#define PWM0_DUTY       10
#define PWM1_DUTY       30 
#define PWM2_DUTY       50 
#define PWM3_DUTY       70     
#define PWM4_DUTY       90                                                                                                                               

/************************************************************************************************************
*    Main function 
************************************************************************************************************/
void main(void)
{
    P13 = P14 = P15 = P16 = P17 = 1;        //PWM0~4 shared GPIO P1.3~P1.7 should set 1 before output PWM  
    
    PWMP = PWM_PERIOD;                      //initial PWM period and duty
    PWM0 = PWM0_DUTY * PWM_PERIOD / 100;                   
    PWM1 = PWM1_DUTY * PWM_PERIOD / 100;                
    PWM2 = PWM2_DUTY * PWM_PERIOD / 100;                 
    PWM3 = PWM3_DUTY * PWM_PERIOD / 100; 
    PWM4 = PWM4_DUTY * PWM_PERIOD / 100; 

    PWMCON0 |= 0x55;                        //PWM runs
    PWMCON1 |= 0x01;
    PWMCON0 |= PWM_OUTPUT0;                 //PWM outputs
    PWMCON1 |= PWM_OUTPUT1;

    while(1);
}

