/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2013 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/

//***********************************************************************************************************
//  Nuvoton Technology Corp. 
//  E-Mail: MicroC-8bit@nuvoton.com
//  Date: 20/May/2013  
//***********************************************************************************************************

#include "Timer2.h"
#if DEMO == 1

/*===========================================================================================================
 * Before using this demo code, please set DEMO in "TImer2.h" to decide which *.c is used for different 
 * timer modes.
 *
 * This file set up Timer 2 in Auto-reload up count mode. The timer/counter mode is configured by 
 * configuration wizard. P1.2 toggles each TF2 interrupt and P1.3 toggles each external T2EX interrupt.
 *===========================================================================================================

/*
//-------- <<< Use Configuration Wizard in Context Menu >>> ------------------
//
// <o0.1> Timer/Counter 2 Select
//     <0=> Timer                       <1=> Counter
//
//-------- <<< end of configuration section >>> ------------------------------
*/

#include "N78E366A.H"

#define TIMER_CONTROL   0x00 
#define RELOAD_VALUE_H  0x00
#define RELOAD_VALUE_L  0x00

/************************************************************************************************************
*    TIMER 2 interrupt subroutine
************************************************************************************************************/
void Timer2_ISR (void) interrupt 5  //interrupt address is 0x002B
{
    if (TF2)
    {
        TF2 = 0;
        P12 = ~P12;                 //P1.2 toggle when TF2 interrupt
    }

    if (EXF2)
    {
        EXF2 = 0;
        P13 = ~P13;                 //P1.3 toggle when external T2EX interrupt
    }
}

/************************************************************************************************************
*    Main function 
************************************************************************************************************/
void main (void)
{
    T2CON |= TIMER_CONTROL;         //Timer 2 mode configuration by setting T2CON and T2MOD registers
    EXEN2 = 1;                      //enable T2EX pin reload
    T2MOD = 0x00;                   //select up counter
    
    TH2 = RELOAD_VALUE_H;           //initial counter values 
    TL2 = RELOAD_VALUE_L;    
    RCAP2H = RELOAD_VALUE_H;
    RCAP2L = RELOAD_VALUE_L;    
    
    ET2 = 1;                        //enable Timer2 interrupt
    EA = 1;                         //enable interrupts
    TR2 = 1;                        //Timer2 run

    while(1);
}

#endif