/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2013 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/

//***********************************************************************************************************
//  Nuvoton Technology Corp. 
//  E-Mail: MicroC-8bit@nuvoton.com
//  Date: 20/May/2013 
//***********************************************************************************************************

/*===========================================================================================================
 * This file gives example how to use on-chip XRAM.
 *=========================================================================================================*/
#include "N78E366A.H"
#include "Typedef.h"

#define ERROR_CODE          0x78
#define PASS_CODE           0x5d

/*XRAM is read by MOVX. XRAM can be defined as xdata 1024-element array from absolute address 0x000*/
volatile UINT8 xdata XRAM_variable[1024] _at_ 0x000;

/************************************************************************************************************
*    Main function 
************************************************************************************************************/
void main (void)
{
    UINT16 u16Index;  

    for (u16Index = 0; u16Index <= 1022; u16Index++)
        XRAM_variable[u16Index] = (UINT8)u16Index;

    for (u16Index = 0; u16Index <= 1022; u16Index++)
    {
        if (XRAM_variable[u16Index] != (UINT8)u16Index)
        {
            P3 = ERROR_CODE;
            while(1);
        }
    }

    P3 = PASS_CODE;
    while(1);
}

